#include "lock.h"
#include <fcntl.h>
#include <libmp/util.h>
#include <string.h>
#include <unistd.h>

lock_st lock(lm_ctx_t *ctx) {
  if (NULL == ctx->data)
    return LOCK_ERROR;

  char lock_file[strlen(ctx->data) + 10];
  join(lock_file, ctx->data, "lock");

  if (exists(lock_file))
    return ALREADY_LOCKED;
  if (creat(lock_file, 0600) == -1)
    return LOCK_ERROR;
  return LOCK_SUCCESS;
}

void unlock(lm_ctx_t *ctx) {
  if (NULL == ctx->data)
    return;

  char lock_file[strlen(ctx->data) + 10];
  join(lock_file, ctx->data, "lock");
  unlink(lock_file);
}
